/*
 * This file is a part of the SteamWar software.
 *
 * Copyright (C) 2021  SteamWar.de-Serverteam
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

package de.steamwar.bausystem.region.flags.flagvalues;

import de.steamwar.bausystem.region.flags.Flag;
import lombok.AllArgsConstructor;
import lombok.Getter;

@Getter
@AllArgsConstructor
public enum FireMode implements Flag.Value<FireMode> {

	ALLOW("FLAG_FIRE_ALLOW"),
	DENY("FLAG_FIRE_DENY");

	private static FireMode[] values;
	private final String chatValue;

	@Override
	public FireMode[] getValues() {
		if (FireMode.values == null) {
			FireMode.values = FireMode.values(); //NOSONAR
		}
		return FireMode.values;
	}

	@Override
	public FireMode getValue() {
		return this;
	}

	@Override
	public FireMode getValueOf(final String name) {
		try {
			return FireMode.valueOf(name.toUpperCase());
		} catch (IllegalArgumentException e) {
			if (name.equalsIgnoreCase("false")) {
				return FireMode.DENY;
			}
			return FireMode.ALLOW;
		}
	}
}